Imports System
Imports System.Threading
Imports System.Drawing
Imports System.Collections
Imports System.ComponentModel
Imports System.Windows.Forms
Imports System.Data
Imports System.Net
Imports System.Net.Sockets


Public Class AutoRefresh
    Inherits System.Windows.Forms.Form

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer
    Private WithEvents GB_AcquisitionMode As System.Windows.Forms.GroupBox
    Private WithEvents L_Info As System.Windows.Forms.Label
    Private WithEvents RB_DataServer As System.Windows.Forms.RadioButton
    Private WithEvents RB_SOAP As System.Windows.Forms.RadioButton
    Private WithEvents TB_Values As System.Windows.Forms.TextBox
    Private WithEvents GB_ConversionTime As System.Windows.Forms.GroupBox
    Private WithEvents label11 As System.Windows.Forms.Label
    Private WithEvents TB_ConversionTimeValue As System.Windows.Forms.TextBox
    Private WithEvents label16 As System.Windows.Forms.Label
    Private WithEvents CB_ConversionTimeUnit As System.Windows.Forms.ComboBox
    Private WithEvents label15 As System.Windows.Forms.Label
    Private WithEvents GB_Average As System.Windows.Forms.GroupBox
    Private WithEvents TB_AverageValue As System.Windows.Forms.TextBox
    Private WithEvents CB_AverageMode As System.Windows.Forms.ComboBox
    Private WithEvents label14 As System.Windows.Forms.Label
    Private WithEvents label13 As System.Windows.Forms.Label
    Private WithEvents GB_DataFormat As System.Windows.Forms.GroupBox
    Private WithEvents CHB_DataFormatAnalogValue As System.Windows.Forms.CheckBox
    Private WithEvents CHB_DataFormatTimeStamp As System.Windows.Forms.CheckBox
    Private WithEvents GB_Trigger As System.Windows.Forms.GroupBox
    Private WithEvents TB_NbrOfSeqForEachTrigger As System.Windows.Forms.TextBox
    Private WithEvents label12 As System.Windows.Forms.Label
    Private WithEvents CB_TriggerMode As System.Windows.Forms.ComboBox
    Private WithEvents label10 As System.Windows.Forms.Label
    Private WithEvents label7 As System.Windows.Forms.Label
    Private WithEvents CB_TriggerMask As System.Windows.Forms.ComboBox
    Private WithEvents TB_HardwareTriggerCount As System.Windows.Forms.TextBox
    Private WithEvents label9 As System.Windows.Forms.Label
    Private WithEvents Label1 As System.Windows.Forms.Label
    Private WithEvents CB_HardwareTriggerEdge As System.Windows.Forms.ComboBox
    Private WithEvents GB_Channel As System.Windows.Forms.GroupBox
    Private WithEvents CB_Polarity15 As System.Windows.Forms.ComboBox
    Private WithEvents CB_Polarity14 As System.Windows.Forms.ComboBox
    Private WithEvents CB_Polarity13 As System.Windows.Forms.ComboBox
    Private WithEvents CB_Polarity12 As System.Windows.Forms.ComboBox
    Private WithEvents CB_Polarity11 As System.Windows.Forms.ComboBox
    Private WithEvents CB_Polarity10 As System.Windows.Forms.ComboBox
    Private WithEvents CB_Polarity9 As System.Windows.Forms.ComboBox
    Private WithEvents CB_Polarity8 As System.Windows.Forms.ComboBox
    Private WithEvents CB_Polarity7 As System.Windows.Forms.ComboBox
    Private WithEvents CB_Polarity6 As System.Windows.Forms.ComboBox
    Private WithEvents CB_Polarity5 As System.Windows.Forms.ComboBox
    Private WithEvents CB_Polarity4 As System.Windows.Forms.ComboBox
    Private WithEvents CB_Polarity3 As System.Windows.Forms.ComboBox
    Private WithEvents CB_Polarity2 As System.Windows.Forms.ComboBox
    Private WithEvents CB_Polarity1 As System.Windows.Forms.ComboBox
    Private WithEvents CB_Polarity0 As System.Windows.Forms.ComboBox
    Private WithEvents CB_Gain15 As System.Windows.Forms.ComboBox
    Private WithEvents CB_Gain14 As System.Windows.Forms.ComboBox
    Private WithEvents CB_Gain13 As System.Windows.Forms.ComboBox
    Private WithEvents CB_Gain12 As System.Windows.Forms.ComboBox
    Private WithEvents CB_Gain11 As System.Windows.Forms.ComboBox
    Private WithEvents CB_Gain10 As System.Windows.Forms.ComboBox
    Private WithEvents CB_Gain9 As System.Windows.Forms.ComboBox
    Private WithEvents CB_Gain8 As System.Windows.Forms.ComboBox
    Private WithEvents CB_Gain7 As System.Windows.Forms.ComboBox
    Private WithEvents CB_Gain6 As System.Windows.Forms.ComboBox
    Private WithEvents CB_Gain5 As System.Windows.Forms.ComboBox
    Private WithEvents CB_Gain4 As System.Windows.Forms.ComboBox
    Private WithEvents CB_Gain3 As System.Windows.Forms.ComboBox
    Private WithEvents CB_Gain2 As System.Windows.Forms.ComboBox
    Private WithEvents CB_Gain1 As System.Windows.Forms.ComboBox
    Private WithEvents CHB_Ch15 As System.Windows.Forms.CheckBox
    Private WithEvents CHB_Ch14 As System.Windows.Forms.CheckBox
    Private WithEvents CB_Gain0 As System.Windows.Forms.ComboBox
    Private WithEvents CHB_Ch13 As System.Windows.Forms.CheckBox
    Private WithEvents CHB_Ch12 As System.Windows.Forms.CheckBox
    Private WithEvents CHB_Ch11 As System.Windows.Forms.CheckBox
    Private WithEvents CHB_Ch10 As System.Windows.Forms.CheckBox
    Private WithEvents CHB_Ch9 As System.Windows.Forms.CheckBox
    Private WithEvents CHB_Ch8 As System.Windows.Forms.CheckBox
    Private WithEvents CHB_Ch7 As System.Windows.Forms.CheckBox
    Private WithEvents CHB_Ch6 As System.Windows.Forms.CheckBox
    Private WithEvents CHB_Ch5 As System.Windows.Forms.CheckBox
    Private WithEvents CHB_Ch4 As System.Windows.Forms.CheckBox
    Private WithEvents CHB_Ch3 As System.Windows.Forms.CheckBox
    Private WithEvents CHB_Ch2 As System.Windows.Forms.CheckBox
    Private WithEvents CHB_Ch1 As System.Windows.Forms.CheckBox
    Private WithEvents CHB_Ch0 As System.Windows.Forms.CheckBox
    Private WithEvents label4 As System.Windows.Forms.Label
    Private WithEvents label6 As System.Windows.Forms.Label
    Private WithEvents label5 As System.Windows.Forms.Label
    Private WithEvents GB_Help As System.Windows.Forms.GroupBox
    Private WithEvents L_Help As System.Windows.Forms.Label
    Private WithEvents GB_Description As System.Windows.Forms.GroupBox
    Private WithEvents L_Description As System.Windows.Forms.Label
    Private WithEvents B_StopSample As System.Windows.Forms.Button
    Private WithEvents B_StartSample As System.Windows.Forms.Button
    Private WithEvents label3 As System.Windows.Forms.Label
    Private WithEvents Label2 As System.Windows.Forms.Label
    Private WithEvents Label17 As System.Windows.Forms.Label
    Private WithEvents TB_IPAddress_3 As System.Windows.Forms.TextBox
    Private WithEvents TB_IPAddress_2 As System.Windows.Forms.TextBox
    Private WithEvents TB_IPAddress_1 As System.Windows.Forms.TextBox
    Private WithEvents TB_IPAddress_0 As System.Windows.Forms.TextBox
    Private WithEvents label19 As System.Windows.Forms.Label
    Private WithEvents ReadTimer As System.Windows.Forms.Timer
    Private WithEvents DisplayTimer As System.Windows.Forms.Timer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents Label8 As System.Windows.Forms.Label
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.components = New System.ComponentModel.Container
        Dim resources As System.ComponentModel.ComponentResourceManager = New System.ComponentModel.ComponentResourceManager(GetType(AutoRefresh))
        Me.Label8 = New System.Windows.Forms.Label
        Me.GB_AcquisitionMode = New System.Windows.Forms.GroupBox
        Me.L_Info = New System.Windows.Forms.Label
        Me.RB_DataServer = New System.Windows.Forms.RadioButton
        Me.RB_SOAP = New System.Windows.Forms.RadioButton
        Me.TB_Values = New System.Windows.Forms.TextBox
        Me.GB_ConversionTime = New System.Windows.Forms.GroupBox
        Me.label11 = New System.Windows.Forms.Label
        Me.TB_ConversionTimeValue = New System.Windows.Forms.TextBox
        Me.label16 = New System.Windows.Forms.Label
        Me.CB_ConversionTimeUnit = New System.Windows.Forms.ComboBox
        Me.label15 = New System.Windows.Forms.Label
        Me.GB_Average = New System.Windows.Forms.GroupBox
        Me.TB_AverageValue = New System.Windows.Forms.TextBox
        Me.CB_AverageMode = New System.Windows.Forms.ComboBox
        Me.label14 = New System.Windows.Forms.Label
        Me.label13 = New System.Windows.Forms.Label
        Me.GB_DataFormat = New System.Windows.Forms.GroupBox
        Me.CHB_DataFormatAnalogValue = New System.Windows.Forms.CheckBox
        Me.CHB_DataFormatTimeStamp = New System.Windows.Forms.CheckBox
        Me.GB_Trigger = New System.Windows.Forms.GroupBox
        Me.TB_NbrOfSeqForEachTrigger = New System.Windows.Forms.TextBox
        Me.label12 = New System.Windows.Forms.Label
        Me.CB_TriggerMode = New System.Windows.Forms.ComboBox
        Me.label10 = New System.Windows.Forms.Label
        Me.label7 = New System.Windows.Forms.Label
        Me.CB_TriggerMask = New System.Windows.Forms.ComboBox
        Me.TB_HardwareTriggerCount = New System.Windows.Forms.TextBox
        Me.label9 = New System.Windows.Forms.Label
        Me.Label1 = New System.Windows.Forms.Label
        Me.CB_HardwareTriggerEdge = New System.Windows.Forms.ComboBox
        Me.GB_Channel = New System.Windows.Forms.GroupBox
        Me.CB_Polarity15 = New System.Windows.Forms.ComboBox
        Me.CB_Polarity14 = New System.Windows.Forms.ComboBox
        Me.CB_Polarity13 = New System.Windows.Forms.ComboBox
        Me.CB_Polarity12 = New System.Windows.Forms.ComboBox
        Me.CB_Polarity11 = New System.Windows.Forms.ComboBox
        Me.CB_Polarity10 = New System.Windows.Forms.ComboBox
        Me.CB_Polarity9 = New System.Windows.Forms.ComboBox
        Me.CB_Polarity8 = New System.Windows.Forms.ComboBox
        Me.CB_Polarity7 = New System.Windows.Forms.ComboBox
        Me.CB_Polarity6 = New System.Windows.Forms.ComboBox
        Me.CB_Polarity5 = New System.Windows.Forms.ComboBox
        Me.CB_Polarity4 = New System.Windows.Forms.ComboBox
        Me.CB_Polarity3 = New System.Windows.Forms.ComboBox
        Me.CB_Polarity2 = New System.Windows.Forms.ComboBox
        Me.CB_Polarity1 = New System.Windows.Forms.ComboBox
        Me.CB_Polarity0 = New System.Windows.Forms.ComboBox
        Me.CB_Gain15 = New System.Windows.Forms.ComboBox
        Me.CB_Gain14 = New System.Windows.Forms.ComboBox
        Me.CB_Gain13 = New System.Windows.Forms.ComboBox
        Me.CB_Gain12 = New System.Windows.Forms.ComboBox
        Me.CB_Gain11 = New System.Windows.Forms.ComboBox
        Me.CB_Gain10 = New System.Windows.Forms.ComboBox
        Me.CB_Gain9 = New System.Windows.Forms.ComboBox
        Me.CB_Gain8 = New System.Windows.Forms.ComboBox
        Me.CB_Gain7 = New System.Windows.Forms.ComboBox
        Me.CB_Gain6 = New System.Windows.Forms.ComboBox
        Me.CB_Gain5 = New System.Windows.Forms.ComboBox
        Me.CB_Gain4 = New System.Windows.Forms.ComboBox
        Me.CB_Gain3 = New System.Windows.Forms.ComboBox
        Me.CB_Gain2 = New System.Windows.Forms.ComboBox
        Me.CB_Gain1 = New System.Windows.Forms.ComboBox
        Me.CHB_Ch15 = New System.Windows.Forms.CheckBox
        Me.CHB_Ch14 = New System.Windows.Forms.CheckBox
        Me.CB_Gain0 = New System.Windows.Forms.ComboBox
        Me.CHB_Ch13 = New System.Windows.Forms.CheckBox
        Me.CHB_Ch12 = New System.Windows.Forms.CheckBox
        Me.CHB_Ch11 = New System.Windows.Forms.CheckBox
        Me.CHB_Ch10 = New System.Windows.Forms.CheckBox
        Me.CHB_Ch9 = New System.Windows.Forms.CheckBox
        Me.CHB_Ch8 = New System.Windows.Forms.CheckBox
        Me.CHB_Ch7 = New System.Windows.Forms.CheckBox
        Me.CHB_Ch6 = New System.Windows.Forms.CheckBox
        Me.CHB_Ch5 = New System.Windows.Forms.CheckBox
        Me.CHB_Ch4 = New System.Windows.Forms.CheckBox
        Me.CHB_Ch3 = New System.Windows.Forms.CheckBox
        Me.CHB_Ch2 = New System.Windows.Forms.CheckBox
        Me.CHB_Ch1 = New System.Windows.Forms.CheckBox
        Me.CHB_Ch0 = New System.Windows.Forms.CheckBox
        Me.label4 = New System.Windows.Forms.Label
        Me.label6 = New System.Windows.Forms.Label
        Me.label5 = New System.Windows.Forms.Label
        Me.GB_Help = New System.Windows.Forms.GroupBox
        Me.L_Help = New System.Windows.Forms.Label
        Me.GB_Description = New System.Windows.Forms.GroupBox
        Me.L_Description = New System.Windows.Forms.Label
        Me.B_StopSample = New System.Windows.Forms.Button
        Me.B_StartSample = New System.Windows.Forms.Button
        Me.label3 = New System.Windows.Forms.Label
        Me.Label2 = New System.Windows.Forms.Label
        Me.Label17 = New System.Windows.Forms.Label
        Me.TB_IPAddress_3 = New System.Windows.Forms.TextBox
        Me.TB_IPAddress_2 = New System.Windows.Forms.TextBox
        Me.TB_IPAddress_1 = New System.Windows.Forms.TextBox
        Me.TB_IPAddress_0 = New System.Windows.Forms.TextBox
        Me.label19 = New System.Windows.Forms.Label
        Me.ReadTimer = New System.Windows.Forms.Timer(Me.components)
        Me.DisplayTimer = New System.Windows.Forms.Timer(Me.components)
        Me.GB_AcquisitionMode.SuspendLayout()
        Me.GB_ConversionTime.SuspendLayout()
        Me.GB_Average.SuspendLayout()
        Me.GB_DataFormat.SuspendLayout()
        Me.GB_Trigger.SuspendLayout()
        Me.GB_Channel.SuspendLayout()
        Me.GB_Help.SuspendLayout()
        Me.GB_Description.SuspendLayout()
        Me.SuspendLayout()
        '
        'Label8
        '
        Me.Label8.Location = New System.Drawing.Point(0, 0)
        Me.Label8.Name = "Label8"
        Me.Label8.Size = New System.Drawing.Size(100, 23)
        Me.Label8.TabIndex = 0
        '
        'GB_AcquisitionMode
        '
        Me.GB_AcquisitionMode.Controls.Add(Me.L_Info)
        Me.GB_AcquisitionMode.Controls.Add(Me.RB_DataServer)
        Me.GB_AcquisitionMode.Controls.Add(Me.RB_SOAP)
        Me.GB_AcquisitionMode.Location = New System.Drawing.Point(532, 455)
        Me.GB_AcquisitionMode.Name = "GB_AcquisitionMode"
        Me.GB_AcquisitionMode.Size = New System.Drawing.Size(301, 93)
        Me.GB_AcquisitionMode.TabIndex = 177
        Me.GB_AcquisitionMode.TabStop = False
        Me.GB_AcquisitionMode.Text = "Acquisition mode"
        '
        'L_Info
        '
        Me.L_Info.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.L_Info.ForeColor = System.Drawing.Color.Navy
        Me.L_Info.Location = New System.Drawing.Point(33, 60)
        Me.L_Info.Name = "L_Info"
        Me.L_Info.Size = New System.Drawing.Size(254, 30)
        Me.L_Info.TabIndex = 2
        Me.L_Info.Text = "It is recommended to set the blocking mode for the data server via the web page"
        Me.L_Info.Visible = False
        '
        'RB_DataServer
        '
        Me.RB_DataServer.AutoSize = True
        Me.RB_DataServer.Location = New System.Drawing.Point(15, 42)
        Me.RB_DataServer.Name = "RB_DataServer"
        Me.RB_DataServer.Size = New System.Drawing.Size(167, 17)
        Me.RB_DataServer.TabIndex = 1
        Me.RB_DataServer.TabStop = True
        Me.RB_DataServer.Text = "Acquisition via the data server"
        Me.RB_DataServer.UseVisualStyleBackColor = True
        '
        'RB_SOAP
        '
        Me.RB_SOAP.AutoSize = True
        Me.RB_SOAP.Checked = True
        Me.RB_SOAP.Location = New System.Drawing.Point(16, 21)
        Me.RB_SOAP.Name = "RB_SOAP"
        Me.RB_SOAP.Size = New System.Drawing.Size(184, 17)
        Me.RB_SOAP.TabIndex = 0
        Me.RB_SOAP.TabStop = True
        Me.RB_SOAP.Text = "Acquisition via the SOAP function"
        Me.RB_SOAP.UseVisualStyleBackColor = True
        '
        'TB_Values
        '
        Me.TB_Values.Font = New System.Drawing.Font("Courier New", 9.0!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.TB_Values.Location = New System.Drawing.Point(12, 564)
        Me.TB_Values.Multiline = True
        Me.TB_Values.Name = "TB_Values"
        Me.TB_Values.ReadOnly = True
        Me.TB_Values.ScrollBars = System.Windows.Forms.ScrollBars.Both
        Me.TB_Values.Size = New System.Drawing.Size(856, 144)
        Me.TB_Values.TabIndex = 176
        '
        'GB_ConversionTime
        '
        Me.GB_ConversionTime.Controls.Add(Me.label11)
        Me.GB_ConversionTime.Controls.Add(Me.TB_ConversionTimeValue)
        Me.GB_ConversionTime.Controls.Add(Me.label16)
        Me.GB_ConversionTime.Controls.Add(Me.CB_ConversionTimeUnit)
        Me.GB_ConversionTime.Controls.Add(Me.label15)
        Me.GB_ConversionTime.Location = New System.Drawing.Point(532, 356)
        Me.GB_ConversionTime.Name = "GB_ConversionTime"
        Me.GB_ConversionTime.Size = New System.Drawing.Size(301, 88)
        Me.GB_ConversionTime.TabIndex = 175
        Me.GB_ConversionTime.TabStop = False
        Me.GB_ConversionTime.Text = "Conversion time configuration"
        '
        'label11
        '
        Me.label11.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Underline, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.label11.Location = New System.Drawing.Point(200, 32)
        Me.label11.Name = "label11"
        Me.label11.Size = New System.Drawing.Size(64, 16)
        Me.label11.TabIndex = 20
        Me.label11.Text = "(min 10 us)"
        '
        'TB_ConversionTimeValue
        '
        Me.TB_ConversionTimeValue.Location = New System.Drawing.Point(96, 56)
        Me.TB_ConversionTimeValue.Name = "TB_ConversionTimeValue"
        Me.TB_ConversionTimeValue.Size = New System.Drawing.Size(80, 20)
        Me.TB_ConversionTimeValue.TabIndex = 19
        Me.TB_ConversionTimeValue.Text = "40"
        '
        'label16
        '
        Me.label16.Location = New System.Drawing.Point(8, 64)
        Me.label16.Name = "label16"
        Me.label16.Size = New System.Drawing.Size(72, 16)
        Me.label16.TabIndex = 14
        Me.label16.Text = "Time value :"
        '
        'CB_ConversionTimeUnit
        '
        Me.CB_ConversionTimeUnit.Items.AddRange(New Object() {"us", "ms", "s"})
        Me.CB_ConversionTimeUnit.Location = New System.Drawing.Point(96, 24)
        Me.CB_ConversionTimeUnit.Name = "CB_ConversionTimeUnit"
        Me.CB_ConversionTimeUnit.Size = New System.Drawing.Size(80, 21)
        Me.CB_ConversionTimeUnit.TabIndex = 13
        Me.CB_ConversionTimeUnit.Text = "us"
        '
        'label15
        '
        Me.label15.Location = New System.Drawing.Point(8, 32)
        Me.label15.Name = "label15"
        Me.label15.Size = New System.Drawing.Size(64, 16)
        Me.label15.TabIndex = 11
        Me.label15.Text = "Time unit :"
        '
        'GB_Average
        '
        Me.GB_Average.Controls.Add(Me.TB_AverageValue)
        Me.GB_Average.Controls.Add(Me.CB_AverageMode)
        Me.GB_Average.Controls.Add(Me.label14)
        Me.GB_Average.Controls.Add(Me.label13)
        Me.GB_Average.Location = New System.Drawing.Point(292, 455)
        Me.GB_Average.Name = "GB_Average"
        Me.GB_Average.Size = New System.Drawing.Size(224, 93)
        Me.GB_Average.TabIndex = 174
        Me.GB_Average.TabStop = False
        Me.GB_Average.Text = "Average configuration"
        '
        'TB_AverageValue
        '
        Me.TB_AverageValue.Location = New System.Drawing.Point(104, 54)
        Me.TB_AverageValue.Name = "TB_AverageValue"
        Me.TB_AverageValue.Size = New System.Drawing.Size(104, 20)
        Me.TB_AverageValue.TabIndex = 18
        Me.TB_AverageValue.Text = "1"
        '
        'CB_AverageMode
        '
        Me.CB_AverageMode.Items.AddRange(New Object() {"No average", "per sequence", "per channel"})
        Me.CB_AverageMode.Location = New System.Drawing.Point(104, 27)
        Me.CB_AverageMode.Name = "CB_AverageMode"
        Me.CB_AverageMode.Size = New System.Drawing.Size(104, 21)
        Me.CB_AverageMode.TabIndex = 12
        Me.CB_AverageMode.Text = "No average"
        '
        'label14
        '
        Me.label14.Location = New System.Drawing.Point(8, 56)
        Me.label14.Name = "label14"
        Me.label14.Size = New System.Drawing.Size(88, 16)
        Me.label14.TabIndex = 11
        Me.label14.Text = "Average value :"
        '
        'label13
        '
        Me.label13.Location = New System.Drawing.Point(8, 30)
        Me.label13.Name = "label13"
        Me.label13.Size = New System.Drawing.Size(88, 16)
        Me.label13.TabIndex = 10
        Me.label13.Text = "Average mode :"
        '
        'GB_DataFormat
        '
        Me.GB_DataFormat.Controls.Add(Me.CHB_DataFormatAnalogValue)
        Me.GB_DataFormat.Controls.Add(Me.CHB_DataFormatTimeStamp)
        Me.GB_DataFormat.Location = New System.Drawing.Point(292, 356)
        Me.GB_DataFormat.Name = "GB_DataFormat"
        Me.GB_DataFormat.Size = New System.Drawing.Size(224, 88)
        Me.GB_DataFormat.TabIndex = 173
        Me.GB_DataFormat.TabStop = False
        Me.GB_DataFormat.Text = "Data format"
        '
        'CHB_DataFormatAnalogValue
        '
        Me.CHB_DataFormatAnalogValue.Location = New System.Drawing.Point(16, 48)
        Me.CHB_DataFormatAnalogValue.Name = "CHB_DataFormatAnalogValue"
        Me.CHB_DataFormatAnalogValue.Size = New System.Drawing.Size(144, 24)
        Me.CHB_DataFormatAnalogValue.TabIndex = 1
        Me.CHB_DataFormatAnalogValue.Text = "Convert in analog value"
        '
        'CHB_DataFormatTimeStamp
        '
        Me.CHB_DataFormatTimeStamp.Location = New System.Drawing.Point(16, 24)
        Me.CHB_DataFormatTimeStamp.Name = "CHB_DataFormatTimeStamp"
        Me.CHB_DataFormatTimeStamp.Size = New System.Drawing.Size(104, 24)
        Me.CHB_DataFormatTimeStamp.TabIndex = 0
        Me.CHB_DataFormatTimeStamp.Text = "With time stamp"
        '
        'GB_Trigger
        '
        Me.GB_Trigger.Controls.Add(Me.TB_NbrOfSeqForEachTrigger)
        Me.GB_Trigger.Controls.Add(Me.label12)
        Me.GB_Trigger.Controls.Add(Me.CB_TriggerMode)
        Me.GB_Trigger.Controls.Add(Me.label10)
        Me.GB_Trigger.Controls.Add(Me.label7)
        Me.GB_Trigger.Controls.Add(Me.CB_TriggerMask)
        Me.GB_Trigger.Controls.Add(Me.TB_HardwareTriggerCount)
        Me.GB_Trigger.Controls.Add(Me.label9)
        Me.GB_Trigger.Controls.Add(Me.Label1)
        Me.GB_Trigger.Controls.Add(Me.CB_HardwareTriggerEdge)
        Me.GB_Trigger.Location = New System.Drawing.Point(12, 356)
        Me.GB_Trigger.Name = "GB_Trigger"
        Me.GB_Trigger.Size = New System.Drawing.Size(264, 192)
        Me.GB_Trigger.TabIndex = 172
        Me.GB_Trigger.TabStop = False
        Me.GB_Trigger.Text = "Trigger configuration"
        '
        'TB_NbrOfSeqForEachTrigger
        '
        Me.TB_NbrOfSeqForEachTrigger.Enabled = False
        Me.TB_NbrOfSeqForEachTrigger.Location = New System.Drawing.Point(168, 152)
        Me.TB_NbrOfSeqForEachTrigger.Name = "TB_NbrOfSeqForEachTrigger"
        Me.TB_NbrOfSeqForEachTrigger.Size = New System.Drawing.Size(80, 20)
        Me.TB_NbrOfSeqForEachTrigger.TabIndex = 17
        Me.TB_NbrOfSeqForEachTrigger.Text = "1"
        '
        'label12
        '
        Me.label12.Location = New System.Drawing.Point(16, 152)
        Me.label12.Name = "label12"
        Me.label12.Size = New System.Drawing.Size(128, 24)
        Me.label12.TabIndex = 16
        Me.label12.Text = "Nbr of Sequence to acquire for each trigger :"
        '
        'CB_TriggerMode
        '
        Me.CB_TriggerMode.Enabled = False
        Me.CB_TriggerMode.Items.AddRange(New Object() {"Single shot", "Sequence"})
        Me.CB_TriggerMode.Location = New System.Drawing.Point(168, 112)
        Me.CB_TriggerMode.Name = "CB_TriggerMode"
        Me.CB_TriggerMode.Size = New System.Drawing.Size(80, 21)
        Me.CB_TriggerMode.TabIndex = 15
        Me.CB_TriggerMode.Text = "Single shot"
        '
        'label10
        '
        Me.label10.Location = New System.Drawing.Point(16, 120)
        Me.label10.Name = "label10"
        Me.label10.Size = New System.Drawing.Size(128, 16)
        Me.label10.TabIndex = 14
        Me.label10.Text = "Trigger mode :"
        '
        'label7
        '
        Me.label7.Location = New System.Drawing.Point(16, 16)
        Me.label7.Name = "label7"
        Me.label7.Size = New System.Drawing.Size(80, 23)
        Me.label7.TabIndex = 7
        Me.label7.Text = "Trigger mask :"
        '
        'CB_TriggerMask
        '
        Me.CB_TriggerMask.Items.AddRange(New Object() {"No trigger", "Digital input trigger", "Synchro trigger"})
        Me.CB_TriggerMask.Location = New System.Drawing.Point(96, 16)
        Me.CB_TriggerMask.Name = "CB_TriggerMask"
        Me.CB_TriggerMask.Size = New System.Drawing.Size(152, 21)
        Me.CB_TriggerMask.TabIndex = 6
        Me.CB_TriggerMask.Text = "No trigger"
        '
        'TB_HardwareTriggerCount
        '
        Me.TB_HardwareTriggerCount.Enabled = False
        Me.TB_HardwareTriggerCount.Location = New System.Drawing.Point(168, 80)
        Me.TB_HardwareTriggerCount.Name = "TB_HardwareTriggerCount"
        Me.TB_HardwareTriggerCount.Size = New System.Drawing.Size(80, 20)
        Me.TB_HardwareTriggerCount.TabIndex = 11
        Me.TB_HardwareTriggerCount.Text = "1"
        '
        'label9
        '
        Me.label9.Location = New System.Drawing.Point(16, 88)
        Me.label9.Name = "label9"
        Me.label9.Size = New System.Drawing.Size(128, 16)
        Me.label9.TabIndex = 10
        Me.label9.Text = "Hardware trigger Count :"
        '
        'Label1
        '
        Me.Label1.Location = New System.Drawing.Point(16, 56)
        Me.Label1.Name = "Label1"
        Me.Label1.Size = New System.Drawing.Size(128, 16)
        Me.Label1.TabIndex = 9
        Me.Label1.Text = "Hardware trigger edge :"
        '
        'CB_HardwareTriggerEdge
        '
        Me.CB_HardwareTriggerEdge.Enabled = False
        Me.CB_HardwareTriggerEdge.Items.AddRange(New Object() {"Rising edge", "Falling edge", "Both edge"})
        Me.CB_HardwareTriggerEdge.Location = New System.Drawing.Point(168, 48)
        Me.CB_HardwareTriggerEdge.Name = "CB_HardwareTriggerEdge"
        Me.CB_HardwareTriggerEdge.Size = New System.Drawing.Size(80, 21)
        Me.CB_HardwareTriggerEdge.TabIndex = 8
        Me.CB_HardwareTriggerEdge.Text = "Rising edge"
        '
        'GB_Channel
        '
        Me.GB_Channel.Controls.Add(Me.CB_Polarity15)
        Me.GB_Channel.Controls.Add(Me.CB_Polarity14)
        Me.GB_Channel.Controls.Add(Me.CB_Polarity13)
        Me.GB_Channel.Controls.Add(Me.CB_Polarity12)
        Me.GB_Channel.Controls.Add(Me.CB_Polarity11)
        Me.GB_Channel.Controls.Add(Me.CB_Polarity10)
        Me.GB_Channel.Controls.Add(Me.CB_Polarity9)
        Me.GB_Channel.Controls.Add(Me.CB_Polarity8)
        Me.GB_Channel.Controls.Add(Me.CB_Polarity7)
        Me.GB_Channel.Controls.Add(Me.CB_Polarity6)
        Me.GB_Channel.Controls.Add(Me.CB_Polarity5)
        Me.GB_Channel.Controls.Add(Me.CB_Polarity4)
        Me.GB_Channel.Controls.Add(Me.CB_Polarity3)
        Me.GB_Channel.Controls.Add(Me.CB_Polarity2)
        Me.GB_Channel.Controls.Add(Me.CB_Polarity1)
        Me.GB_Channel.Controls.Add(Me.CB_Polarity0)
        Me.GB_Channel.Controls.Add(Me.CB_Gain15)
        Me.GB_Channel.Controls.Add(Me.CB_Gain14)
        Me.GB_Channel.Controls.Add(Me.CB_Gain13)
        Me.GB_Channel.Controls.Add(Me.CB_Gain12)
        Me.GB_Channel.Controls.Add(Me.CB_Gain11)
        Me.GB_Channel.Controls.Add(Me.CB_Gain10)
        Me.GB_Channel.Controls.Add(Me.CB_Gain9)
        Me.GB_Channel.Controls.Add(Me.CB_Gain8)
        Me.GB_Channel.Controls.Add(Me.CB_Gain7)
        Me.GB_Channel.Controls.Add(Me.CB_Gain6)
        Me.GB_Channel.Controls.Add(Me.CB_Gain5)
        Me.GB_Channel.Controls.Add(Me.CB_Gain4)
        Me.GB_Channel.Controls.Add(Me.CB_Gain3)
        Me.GB_Channel.Controls.Add(Me.CB_Gain2)
        Me.GB_Channel.Controls.Add(Me.CB_Gain1)
        Me.GB_Channel.Controls.Add(Me.CHB_Ch15)
        Me.GB_Channel.Controls.Add(Me.CHB_Ch14)
        Me.GB_Channel.Controls.Add(Me.CB_Gain0)
        Me.GB_Channel.Controls.Add(Me.CHB_Ch13)
        Me.GB_Channel.Controls.Add(Me.CHB_Ch12)
        Me.GB_Channel.Controls.Add(Me.CHB_Ch11)
        Me.GB_Channel.Controls.Add(Me.CHB_Ch10)
        Me.GB_Channel.Controls.Add(Me.CHB_Ch9)
        Me.GB_Channel.Controls.Add(Me.CHB_Ch8)
        Me.GB_Channel.Controls.Add(Me.CHB_Ch7)
        Me.GB_Channel.Controls.Add(Me.CHB_Ch6)
        Me.GB_Channel.Controls.Add(Me.CHB_Ch5)
        Me.GB_Channel.Controls.Add(Me.CHB_Ch4)
        Me.GB_Channel.Controls.Add(Me.CHB_Ch3)
        Me.GB_Channel.Controls.Add(Me.CHB_Ch2)
        Me.GB_Channel.Controls.Add(Me.CHB_Ch1)
        Me.GB_Channel.Controls.Add(Me.CHB_Ch0)
        Me.GB_Channel.Controls.Add(Me.label4)
        Me.GB_Channel.Controls.Add(Me.label6)
        Me.GB_Channel.Controls.Add(Me.label5)
        Me.GB_Channel.Location = New System.Drawing.Point(12, 220)
        Me.GB_Channel.Name = "GB_Channel"
        Me.GB_Channel.Size = New System.Drawing.Size(856, 120)
        Me.GB_Channel.TabIndex = 171
        Me.GB_Channel.TabStop = False
        Me.GB_Channel.Text = "Channel configuration"
        '
        'CB_Polarity15
        '
        Me.CB_Polarity15.Enabled = False
        Me.CB_Polarity15.Items.AddRange(New Object() {"Uni", "Bip"})
        Me.CB_Polarity15.Location = New System.Drawing.Point(792, 88)
        Me.CB_Polarity15.Name = "CB_Polarity15"
        Me.CB_Polarity15.Size = New System.Drawing.Size(40, 21)
        Me.CB_Polarity15.TabIndex = 70
        Me.CB_Polarity15.Text = "Uni"
        '
        'CB_Polarity14
        '
        Me.CB_Polarity14.Enabled = False
        Me.CB_Polarity14.Items.AddRange(New Object() {"Uni", "Bip"})
        Me.CB_Polarity14.Location = New System.Drawing.Point(744, 88)
        Me.CB_Polarity14.Name = "CB_Polarity14"
        Me.CB_Polarity14.Size = New System.Drawing.Size(40, 21)
        Me.CB_Polarity14.TabIndex = 69
        Me.CB_Polarity14.Text = "Uni"
        '
        'CB_Polarity13
        '
        Me.CB_Polarity13.Enabled = False
        Me.CB_Polarity13.Items.AddRange(New Object() {"Uni", "Bip"})
        Me.CB_Polarity13.Location = New System.Drawing.Point(696, 88)
        Me.CB_Polarity13.Name = "CB_Polarity13"
        Me.CB_Polarity13.Size = New System.Drawing.Size(40, 21)
        Me.CB_Polarity13.TabIndex = 68
        Me.CB_Polarity13.Text = "Uni"
        '
        'CB_Polarity12
        '
        Me.CB_Polarity12.Enabled = False
        Me.CB_Polarity12.Items.AddRange(New Object() {"Uni", "Bip"})
        Me.CB_Polarity12.Location = New System.Drawing.Point(648, 88)
        Me.CB_Polarity12.Name = "CB_Polarity12"
        Me.CB_Polarity12.Size = New System.Drawing.Size(40, 21)
        Me.CB_Polarity12.TabIndex = 67
        Me.CB_Polarity12.Text = "Uni"
        '
        'CB_Polarity11
        '
        Me.CB_Polarity11.Enabled = False
        Me.CB_Polarity11.Items.AddRange(New Object() {"Uni", "Bip"})
        Me.CB_Polarity11.Location = New System.Drawing.Point(600, 88)
        Me.CB_Polarity11.Name = "CB_Polarity11"
        Me.CB_Polarity11.Size = New System.Drawing.Size(40, 21)
        Me.CB_Polarity11.TabIndex = 66
        Me.CB_Polarity11.Text = "Uni"
        '
        'CB_Polarity10
        '
        Me.CB_Polarity10.Enabled = False
        Me.CB_Polarity10.Items.AddRange(New Object() {"Uni", "Bip"})
        Me.CB_Polarity10.Location = New System.Drawing.Point(552, 88)
        Me.CB_Polarity10.Name = "CB_Polarity10"
        Me.CB_Polarity10.Size = New System.Drawing.Size(40, 21)
        Me.CB_Polarity10.TabIndex = 65
        Me.CB_Polarity10.Text = "Uni"
        '
        'CB_Polarity9
        '
        Me.CB_Polarity9.Enabled = False
        Me.CB_Polarity9.Items.AddRange(New Object() {"Uni", "Bip"})
        Me.CB_Polarity9.Location = New System.Drawing.Point(504, 88)
        Me.CB_Polarity9.Name = "CB_Polarity9"
        Me.CB_Polarity9.Size = New System.Drawing.Size(40, 21)
        Me.CB_Polarity9.TabIndex = 64
        Me.CB_Polarity9.Text = "Uni"
        '
        'CB_Polarity8
        '
        Me.CB_Polarity8.Enabled = False
        Me.CB_Polarity8.Items.AddRange(New Object() {"Uni", "Bip"})
        Me.CB_Polarity8.Location = New System.Drawing.Point(456, 88)
        Me.CB_Polarity8.Name = "CB_Polarity8"
        Me.CB_Polarity8.Size = New System.Drawing.Size(40, 21)
        Me.CB_Polarity8.TabIndex = 63
        Me.CB_Polarity8.Text = "Uni"
        '
        'CB_Polarity7
        '
        Me.CB_Polarity7.Enabled = False
        Me.CB_Polarity7.Items.AddRange(New Object() {"Uni", "Bip"})
        Me.CB_Polarity7.Location = New System.Drawing.Point(408, 88)
        Me.CB_Polarity7.Name = "CB_Polarity7"
        Me.CB_Polarity7.Size = New System.Drawing.Size(40, 21)
        Me.CB_Polarity7.TabIndex = 62
        Me.CB_Polarity7.Text = "Uni"
        '
        'CB_Polarity6
        '
        Me.CB_Polarity6.Enabled = False
        Me.CB_Polarity6.Items.AddRange(New Object() {"Uni", "Bip"})
        Me.CB_Polarity6.Location = New System.Drawing.Point(360, 88)
        Me.CB_Polarity6.Name = "CB_Polarity6"
        Me.CB_Polarity6.Size = New System.Drawing.Size(40, 21)
        Me.CB_Polarity6.TabIndex = 61
        Me.CB_Polarity6.Text = "Uni"
        '
        'CB_Polarity5
        '
        Me.CB_Polarity5.Enabled = False
        Me.CB_Polarity5.Items.AddRange(New Object() {"Uni", "Bip"})
        Me.CB_Polarity5.Location = New System.Drawing.Point(312, 88)
        Me.CB_Polarity5.Name = "CB_Polarity5"
        Me.CB_Polarity5.Size = New System.Drawing.Size(40, 21)
        Me.CB_Polarity5.TabIndex = 60
        Me.CB_Polarity5.Text = "Uni"
        '
        'CB_Polarity4
        '
        Me.CB_Polarity4.Enabled = False
        Me.CB_Polarity4.Items.AddRange(New Object() {"Uni", "Bip"})
        Me.CB_Polarity4.Location = New System.Drawing.Point(264, 88)
        Me.CB_Polarity4.Name = "CB_Polarity4"
        Me.CB_Polarity4.Size = New System.Drawing.Size(40, 21)
        Me.CB_Polarity4.TabIndex = 59
        Me.CB_Polarity4.Text = "Uni"
        '
        'CB_Polarity3
        '
        Me.CB_Polarity3.Enabled = False
        Me.CB_Polarity3.Items.AddRange(New Object() {"Uni", "Bip"})
        Me.CB_Polarity3.Location = New System.Drawing.Point(216, 88)
        Me.CB_Polarity3.Name = "CB_Polarity3"
        Me.CB_Polarity3.Size = New System.Drawing.Size(40, 21)
        Me.CB_Polarity3.TabIndex = 58
        Me.CB_Polarity3.Text = "Uni"
        '
        'CB_Polarity2
        '
        Me.CB_Polarity2.Enabled = False
        Me.CB_Polarity2.Items.AddRange(New Object() {"Uni", "Bip"})
        Me.CB_Polarity2.Location = New System.Drawing.Point(168, 88)
        Me.CB_Polarity2.Name = "CB_Polarity2"
        Me.CB_Polarity2.Size = New System.Drawing.Size(40, 21)
        Me.CB_Polarity2.TabIndex = 57
        Me.CB_Polarity2.Text = "Uni"
        '
        'CB_Polarity1
        '
        Me.CB_Polarity1.Enabled = False
        Me.CB_Polarity1.Items.AddRange(New Object() {"Uni", "Bip"})
        Me.CB_Polarity1.Location = New System.Drawing.Point(120, 88)
        Me.CB_Polarity1.Name = "CB_Polarity1"
        Me.CB_Polarity1.Size = New System.Drawing.Size(40, 21)
        Me.CB_Polarity1.TabIndex = 56
        Me.CB_Polarity1.Text = "Uni"
        '
        'CB_Polarity0
        '
        Me.CB_Polarity0.Items.AddRange(New Object() {"Uni", "Bip"})
        Me.CB_Polarity0.Location = New System.Drawing.Point(72, 88)
        Me.CB_Polarity0.Name = "CB_Polarity0"
        Me.CB_Polarity0.Size = New System.Drawing.Size(40, 21)
        Me.CB_Polarity0.TabIndex = 55
        Me.CB_Polarity0.Text = "Uni"
        '
        'CB_Gain15
        '
        Me.CB_Gain15.Enabled = False
        Me.CB_Gain15.Items.AddRange(New Object() {"1", "2"})
        Me.CB_Gain15.Location = New System.Drawing.Point(792, 56)
        Me.CB_Gain15.Name = "CB_Gain15"
        Me.CB_Gain15.Size = New System.Drawing.Size(40, 21)
        Me.CB_Gain15.TabIndex = 54
        Me.CB_Gain15.Text = "1"
        '
        'CB_Gain14
        '
        Me.CB_Gain14.Enabled = False
        Me.CB_Gain14.Items.AddRange(New Object() {"1", "2"})
        Me.CB_Gain14.Location = New System.Drawing.Point(744, 56)
        Me.CB_Gain14.Name = "CB_Gain14"
        Me.CB_Gain14.Size = New System.Drawing.Size(40, 21)
        Me.CB_Gain14.TabIndex = 53
        Me.CB_Gain14.Text = "1"
        '
        'CB_Gain13
        '
        Me.CB_Gain13.Enabled = False
        Me.CB_Gain13.Items.AddRange(New Object() {"1", "2"})
        Me.CB_Gain13.Location = New System.Drawing.Point(696, 56)
        Me.CB_Gain13.Name = "CB_Gain13"
        Me.CB_Gain13.Size = New System.Drawing.Size(40, 21)
        Me.CB_Gain13.TabIndex = 52
        Me.CB_Gain13.Text = "1"
        '
        'CB_Gain12
        '
        Me.CB_Gain12.Enabled = False
        Me.CB_Gain12.Items.AddRange(New Object() {"1", "2"})
        Me.CB_Gain12.Location = New System.Drawing.Point(648, 56)
        Me.CB_Gain12.Name = "CB_Gain12"
        Me.CB_Gain12.Size = New System.Drawing.Size(40, 21)
        Me.CB_Gain12.TabIndex = 51
        Me.CB_Gain12.Text = "1"
        '
        'CB_Gain11
        '
        Me.CB_Gain11.Enabled = False
        Me.CB_Gain11.Items.AddRange(New Object() {"1", "2"})
        Me.CB_Gain11.Location = New System.Drawing.Point(600, 56)
        Me.CB_Gain11.Name = "CB_Gain11"
        Me.CB_Gain11.Size = New System.Drawing.Size(40, 21)
        Me.CB_Gain11.TabIndex = 50
        Me.CB_Gain11.Text = "1"
        '
        'CB_Gain10
        '
        Me.CB_Gain10.Enabled = False
        Me.CB_Gain10.Items.AddRange(New Object() {"1", "2"})
        Me.CB_Gain10.Location = New System.Drawing.Point(552, 56)
        Me.CB_Gain10.Name = "CB_Gain10"
        Me.CB_Gain10.Size = New System.Drawing.Size(40, 21)
        Me.CB_Gain10.TabIndex = 49
        Me.CB_Gain10.Text = "1"
        '
        'CB_Gain9
        '
        Me.CB_Gain9.Enabled = False
        Me.CB_Gain9.Items.AddRange(New Object() {"1", "2"})
        Me.CB_Gain9.Location = New System.Drawing.Point(504, 56)
        Me.CB_Gain9.Name = "CB_Gain9"
        Me.CB_Gain9.Size = New System.Drawing.Size(40, 21)
        Me.CB_Gain9.TabIndex = 48
        Me.CB_Gain9.Text = "1"
        '
        'CB_Gain8
        '
        Me.CB_Gain8.Enabled = False
        Me.CB_Gain8.Items.AddRange(New Object() {"1", "2"})
        Me.CB_Gain8.Location = New System.Drawing.Point(456, 56)
        Me.CB_Gain8.Name = "CB_Gain8"
        Me.CB_Gain8.Size = New System.Drawing.Size(40, 21)
        Me.CB_Gain8.TabIndex = 47
        Me.CB_Gain8.Text = "1"
        '
        'CB_Gain7
        '
        Me.CB_Gain7.Enabled = False
        Me.CB_Gain7.Items.AddRange(New Object() {"1", "2"})
        Me.CB_Gain7.Location = New System.Drawing.Point(408, 56)
        Me.CB_Gain7.Name = "CB_Gain7"
        Me.CB_Gain7.Size = New System.Drawing.Size(40, 21)
        Me.CB_Gain7.TabIndex = 46
        Me.CB_Gain7.Text = "1"
        '
        'CB_Gain6
        '
        Me.CB_Gain6.Enabled = False
        Me.CB_Gain6.Items.AddRange(New Object() {"1", "2"})
        Me.CB_Gain6.Location = New System.Drawing.Point(360, 56)
        Me.CB_Gain6.Name = "CB_Gain6"
        Me.CB_Gain6.Size = New System.Drawing.Size(40, 21)
        Me.CB_Gain6.TabIndex = 45
        Me.CB_Gain6.Text = "1"
        '
        'CB_Gain5
        '
        Me.CB_Gain5.Enabled = False
        Me.CB_Gain5.Items.AddRange(New Object() {"1", "2"})
        Me.CB_Gain5.Location = New System.Drawing.Point(312, 56)
        Me.CB_Gain5.Name = "CB_Gain5"
        Me.CB_Gain5.Size = New System.Drawing.Size(40, 21)
        Me.CB_Gain5.TabIndex = 44
        Me.CB_Gain5.Text = "1"
        '
        'CB_Gain4
        '
        Me.CB_Gain4.Enabled = False
        Me.CB_Gain4.Items.AddRange(New Object() {"1", "2"})
        Me.CB_Gain4.Location = New System.Drawing.Point(264, 56)
        Me.CB_Gain4.Name = "CB_Gain4"
        Me.CB_Gain4.Size = New System.Drawing.Size(40, 21)
        Me.CB_Gain4.TabIndex = 43
        Me.CB_Gain4.Text = "1"
        '
        'CB_Gain3
        '
        Me.CB_Gain3.Enabled = False
        Me.CB_Gain3.Items.AddRange(New Object() {"1", "2"})
        Me.CB_Gain3.Location = New System.Drawing.Point(216, 56)
        Me.CB_Gain3.Name = "CB_Gain3"
        Me.CB_Gain3.Size = New System.Drawing.Size(40, 21)
        Me.CB_Gain3.TabIndex = 42
        Me.CB_Gain3.Text = "1"
        '
        'CB_Gain2
        '
        Me.CB_Gain2.Enabled = False
        Me.CB_Gain2.Items.AddRange(New Object() {"1", "2"})
        Me.CB_Gain2.Location = New System.Drawing.Point(168, 56)
        Me.CB_Gain2.Name = "CB_Gain2"
        Me.CB_Gain2.Size = New System.Drawing.Size(40, 21)
        Me.CB_Gain2.TabIndex = 41
        Me.CB_Gain2.Text = "1"
        '
        'CB_Gain1
        '
        Me.CB_Gain1.Enabled = False
        Me.CB_Gain1.Items.AddRange(New Object() {"1", "2"})
        Me.CB_Gain1.Location = New System.Drawing.Point(120, 56)
        Me.CB_Gain1.Name = "CB_Gain1"
        Me.CB_Gain1.Size = New System.Drawing.Size(40, 21)
        Me.CB_Gain1.TabIndex = 40
        Me.CB_Gain1.Text = "1"
        '
        'CHB_Ch15
        '
        Me.CHB_Ch15.Location = New System.Drawing.Point(792, 24)
        Me.CHB_Ch15.Name = "CHB_Ch15"
        Me.CHB_Ch15.Size = New System.Drawing.Size(56, 24)
        Me.CHB_Ch15.TabIndex = 37
        Me.CHB_Ch15.Text = "Ch 15"
        '
        'CHB_Ch14
        '
        Me.CHB_Ch14.Location = New System.Drawing.Point(744, 24)
        Me.CHB_Ch14.Name = "CHB_Ch14"
        Me.CHB_Ch14.Size = New System.Drawing.Size(56, 24)
        Me.CHB_Ch14.TabIndex = 39
        Me.CHB_Ch14.Text = "Ch 14"
        '
        'CB_Gain0
        '
        Me.CB_Gain0.Items.AddRange(New Object() {"1", "2"})
        Me.CB_Gain0.Location = New System.Drawing.Point(72, 56)
        Me.CB_Gain0.Name = "CB_Gain0"
        Me.CB_Gain0.Size = New System.Drawing.Size(40, 21)
        Me.CB_Gain0.TabIndex = 38
        Me.CB_Gain0.Text = "1"
        '
        'CHB_Ch13
        '
        Me.CHB_Ch13.Location = New System.Drawing.Point(696, 24)
        Me.CHB_Ch13.Name = "CHB_Ch13"
        Me.CHB_Ch13.Size = New System.Drawing.Size(56, 24)
        Me.CHB_Ch13.TabIndex = 35
        Me.CHB_Ch13.Text = "Ch 13"
        '
        'CHB_Ch12
        '
        Me.CHB_Ch12.Location = New System.Drawing.Point(648, 24)
        Me.CHB_Ch12.Name = "CHB_Ch12"
        Me.CHB_Ch12.Size = New System.Drawing.Size(56, 24)
        Me.CHB_Ch12.TabIndex = 34
        Me.CHB_Ch12.Text = "Ch 12"
        '
        'CHB_Ch11
        '
        Me.CHB_Ch11.Location = New System.Drawing.Point(600, 24)
        Me.CHB_Ch11.Name = "CHB_Ch11"
        Me.CHB_Ch11.Size = New System.Drawing.Size(56, 24)
        Me.CHB_Ch11.TabIndex = 33
        Me.CHB_Ch11.Text = "Ch 11"
        '
        'CHB_Ch10
        '
        Me.CHB_Ch10.Location = New System.Drawing.Point(552, 24)
        Me.CHB_Ch10.Name = "CHB_Ch10"
        Me.CHB_Ch10.Size = New System.Drawing.Size(56, 24)
        Me.CHB_Ch10.TabIndex = 32
        Me.CHB_Ch10.Text = "Ch 10"
        '
        'CHB_Ch9
        '
        Me.CHB_Ch9.Location = New System.Drawing.Point(504, 24)
        Me.CHB_Ch9.Name = "CHB_Ch9"
        Me.CHB_Ch9.Size = New System.Drawing.Size(48, 24)
        Me.CHB_Ch9.TabIndex = 31
        Me.CHB_Ch9.Text = "Ch 9"
        '
        'CHB_Ch8
        '
        Me.CHB_Ch8.Location = New System.Drawing.Point(456, 24)
        Me.CHB_Ch8.Name = "CHB_Ch8"
        Me.CHB_Ch8.Size = New System.Drawing.Size(48, 24)
        Me.CHB_Ch8.TabIndex = 30
        Me.CHB_Ch8.Text = "Ch 8"
        '
        'CHB_Ch7
        '
        Me.CHB_Ch7.Location = New System.Drawing.Point(408, 24)
        Me.CHB_Ch7.Name = "CHB_Ch7"
        Me.CHB_Ch7.Size = New System.Drawing.Size(48, 24)
        Me.CHB_Ch7.TabIndex = 29
        Me.CHB_Ch7.Text = "Ch 7"
        '
        'CHB_Ch6
        '
        Me.CHB_Ch6.Location = New System.Drawing.Point(360, 24)
        Me.CHB_Ch6.Name = "CHB_Ch6"
        Me.CHB_Ch6.Size = New System.Drawing.Size(48, 24)
        Me.CHB_Ch6.TabIndex = 28
        Me.CHB_Ch6.Text = "Ch 6"
        '
        'CHB_Ch5
        '
        Me.CHB_Ch5.Location = New System.Drawing.Point(312, 24)
        Me.CHB_Ch5.Name = "CHB_Ch5"
        Me.CHB_Ch5.Size = New System.Drawing.Size(48, 24)
        Me.CHB_Ch5.TabIndex = 27
        Me.CHB_Ch5.Text = "Ch 5"
        '
        'CHB_Ch4
        '
        Me.CHB_Ch4.Location = New System.Drawing.Point(264, 24)
        Me.CHB_Ch4.Name = "CHB_Ch4"
        Me.CHB_Ch4.Size = New System.Drawing.Size(48, 24)
        Me.CHB_Ch4.TabIndex = 26
        Me.CHB_Ch4.Text = "Ch 4"
        '
        'CHB_Ch3
        '
        Me.CHB_Ch3.Location = New System.Drawing.Point(216, 24)
        Me.CHB_Ch3.Name = "CHB_Ch3"
        Me.CHB_Ch3.Size = New System.Drawing.Size(48, 24)
        Me.CHB_Ch3.TabIndex = 25
        Me.CHB_Ch3.Text = "Ch 3"
        '
        'CHB_Ch2
        '
        Me.CHB_Ch2.Location = New System.Drawing.Point(168, 24)
        Me.CHB_Ch2.Name = "CHB_Ch2"
        Me.CHB_Ch2.Size = New System.Drawing.Size(48, 24)
        Me.CHB_Ch2.TabIndex = 24
        Me.CHB_Ch2.Text = "Ch 2"
        '
        'CHB_Ch1
        '
        Me.CHB_Ch1.Location = New System.Drawing.Point(120, 24)
        Me.CHB_Ch1.Name = "CHB_Ch1"
        Me.CHB_Ch1.Size = New System.Drawing.Size(48, 24)
        Me.CHB_Ch1.TabIndex = 23
        Me.CHB_Ch1.Text = "Ch 1"
        '
        'CHB_Ch0
        '
        Me.CHB_Ch0.Checked = True
        Me.CHB_Ch0.CheckState = System.Windows.Forms.CheckState.Checked
        Me.CHB_Ch0.Location = New System.Drawing.Point(72, 24)
        Me.CHB_Ch0.Name = "CHB_Ch0"
        Me.CHB_Ch0.Size = New System.Drawing.Size(48, 24)
        Me.CHB_Ch0.TabIndex = 22
        Me.CHB_Ch0.Text = "Ch 0"
        '
        'label4
        '
        Me.label4.Location = New System.Drawing.Point(8, 32)
        Me.label4.Name = "label4"
        Me.label4.Size = New System.Drawing.Size(56, 16)
        Me.label4.TabIndex = 21
        Me.label4.Text = "Channel :"
        '
        'label6
        '
        Me.label6.Location = New System.Drawing.Point(8, 96)
        Me.label6.Name = "label6"
        Me.label6.Size = New System.Drawing.Size(48, 16)
        Me.label6.TabIndex = 5
        Me.label6.Text = "Polarity :"
        '
        'label5
        '
        Me.label5.Location = New System.Drawing.Point(8, 64)
        Me.label5.Name = "label5"
        Me.label5.Size = New System.Drawing.Size(48, 16)
        Me.label5.TabIndex = 3
        Me.label5.Text = "Gain :"
        '
        'GB_Help
        '
        Me.GB_Help.Controls.Add(Me.L_Help)
        Me.GB_Help.Location = New System.Drawing.Point(12, 84)
        Me.GB_Help.Name = "GB_Help"
        Me.GB_Help.Size = New System.Drawing.Size(544, 56)
        Me.GB_Help.TabIndex = 170
        Me.GB_Help.TabStop = False
        Me.GB_Help.Text = "Help"
        '
        'L_Help
        '
        Me.L_Help.Location = New System.Drawing.Point(8, 16)
        Me.L_Help.Name = "L_Help"
        Me.L_Help.Size = New System.Drawing.Size(528, 32)
        Me.L_Help.TabIndex = 0
        Me.L_Help.Text = "You must first enter the IP address of the MSX-E301x module, than configure the a" & _
            "uto-refresh and click on button ""Start the sample"" ."
        '
        'GB_Description
        '
        Me.GB_Description.Controls.Add(Me.L_Description)
        Me.GB_Description.Location = New System.Drawing.Point(12, 12)
        Me.GB_Description.Name = "GB_Description"
        Me.GB_Description.Size = New System.Drawing.Size(544, 64)
        Me.GB_Description.TabIndex = 169
        Me.GB_Description.TabStop = False
        Me.GB_Description.Text = "Description"
        '
        'L_Description
        '
        Me.L_Description.Location = New System.Drawing.Point(8, 16)
        Me.L_Description.Name = "L_Description"
        Me.L_Description.Size = New System.Drawing.Size(528, 40)
        Me.L_Description.TabIndex = 0
        Me.L_Description.Text = "This sample  permit to read several analog input in auto-refresh mode"
        '
        'B_StopSample
        '
        Me.B_StopSample.Enabled = False
        Me.B_StopSample.Location = New System.Drawing.Point(268, 180)
        Me.B_StopSample.Name = "B_StopSample"
        Me.B_StopSample.Size = New System.Drawing.Size(288, 24)
        Me.B_StopSample.TabIndex = 168
        Me.B_StopSample.Text = "Stop the sample"
        '
        'B_StartSample
        '
        Me.B_StartSample.Location = New System.Drawing.Point(12, 180)
        Me.B_StartSample.Name = "B_StartSample"
        Me.B_StartSample.Size = New System.Drawing.Size(248, 24)
        Me.B_StartSample.TabIndex = 167
        Me.B_StartSample.Text = "Start the sample"
        '
        'label3
        '
        Me.label3.Font = New System.Drawing.Font("Microsoft Sans Serif", 9.0!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.label3.Location = New System.Drawing.Point(380, 148)
        Me.label3.Name = "label3"
        Me.label3.Size = New System.Drawing.Size(8, 16)
        Me.label3.TabIndex = 166
        Me.label3.Text = "-"
        '
        'Label2
        '
        Me.Label2.Font = New System.Drawing.Font("Microsoft Sans Serif", 9.0!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label2.Location = New System.Drawing.Point(324, 148)
        Me.Label2.Name = "Label2"
        Me.Label2.Size = New System.Drawing.Size(8, 16)
        Me.Label2.TabIndex = 165
        Me.Label2.Text = "-"
        '
        'Label17
        '
        Me.Label17.Font = New System.Drawing.Font("Microsoft Sans Serif", 9.0!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label17.Location = New System.Drawing.Point(268, 148)
        Me.Label17.Name = "Label17"
        Me.Label17.Size = New System.Drawing.Size(8, 16)
        Me.Label17.TabIndex = 164
        Me.Label17.Text = "-"
        '
        'TB_IPAddress_3
        '
        Me.TB_IPAddress_3.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!)
        Me.TB_IPAddress_3.Location = New System.Drawing.Point(396, 148)
        Me.TB_IPAddress_3.MaxLength = 3
        Me.TB_IPAddress_3.Name = "TB_IPAddress_3"
        Me.TB_IPAddress_3.Size = New System.Drawing.Size(32, 20)
        Me.TB_IPAddress_3.TabIndex = 163
        '
        'TB_IPAddress_2
        '
        Me.TB_IPAddress_2.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!)
        Me.TB_IPAddress_2.Location = New System.Drawing.Point(340, 148)
        Me.TB_IPAddress_2.MaxLength = 3
        Me.TB_IPAddress_2.Name = "TB_IPAddress_2"
        Me.TB_IPAddress_2.Size = New System.Drawing.Size(32, 20)
        Me.TB_IPAddress_2.TabIndex = 162
        '
        'TB_IPAddress_1
        '
        Me.TB_IPAddress_1.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!)
        Me.TB_IPAddress_1.Location = New System.Drawing.Point(284, 148)
        Me.TB_IPAddress_1.MaxLength = 3
        Me.TB_IPAddress_1.Name = "TB_IPAddress_1"
        Me.TB_IPAddress_1.Size = New System.Drawing.Size(32, 20)
        Me.TB_IPAddress_1.TabIndex = 161
        '
        'TB_IPAddress_0
        '
        Me.TB_IPAddress_0.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!)
        Me.TB_IPAddress_0.ImeMode = System.Windows.Forms.ImeMode.Disable
        Me.TB_IPAddress_0.Location = New System.Drawing.Point(228, 148)
        Me.TB_IPAddress_0.MaxLength = 3
        Me.TB_IPAddress_0.Name = "TB_IPAddress_0"
        Me.TB_IPAddress_0.Size = New System.Drawing.Size(32, 20)
        Me.TB_IPAddress_0.TabIndex = 160
        '
        'label19
        '
        Me.label19.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.label19.Location = New System.Drawing.Point(12, 148)
        Me.label19.Name = "label19"
        Me.label19.Size = New System.Drawing.Size(208, 16)
        Me.label19.TabIndex = 159
        Me.label19.Text = "IP address of the MSX-E301x module :"
        '
        'ReadTimer
        '
        Me.ReadTimer.Interval = 1
        '
        'DisplayTimer
        '
        '
        'AutoRefresh
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(880, 723)
        Me.Controls.Add(Me.GB_AcquisitionMode)
        Me.Controls.Add(Me.TB_Values)
        Me.Controls.Add(Me.GB_ConversionTime)
        Me.Controls.Add(Me.GB_Average)
        Me.Controls.Add(Me.GB_DataFormat)
        Me.Controls.Add(Me.GB_Trigger)
        Me.Controls.Add(Me.GB_Channel)
        Me.Controls.Add(Me.GB_Help)
        Me.Controls.Add(Me.GB_Description)
        Me.Controls.Add(Me.B_StopSample)
        Me.Controls.Add(Me.B_StartSample)
        Me.Controls.Add(Me.label3)
        Me.Controls.Add(Me.Label2)
        Me.Controls.Add(Me.Label17)
        Me.Controls.Add(Me.TB_IPAddress_3)
        Me.Controls.Add(Me.TB_IPAddress_2)
        Me.Controls.Add(Me.TB_IPAddress_1)
        Me.Controls.Add(Me.TB_IPAddress_0)
        Me.Controls.Add(Me.label19)
        Me.Controls.Add(Me.Label8)
        Me.Icon = CType(resources.GetObject("$this.Icon"), System.Drawing.Icon)
        Me.Name = "AutoRefresh"
        Me.Text = "Auto refresh VB"
        Me.GB_AcquisitionMode.ResumeLayout(False)
        Me.GB_AcquisitionMode.PerformLayout()
        Me.GB_ConversionTime.ResumeLayout(False)
        Me.GB_ConversionTime.PerformLayout()
        Me.GB_Average.ResumeLayout(False)
        Me.GB_Average.PerformLayout()
        Me.GB_DataFormat.ResumeLayout(False)
        Me.GB_Trigger.ResumeLayout(False)
        Me.GB_Trigger.PerformLayout()
        Me.GB_Channel.ResumeLayout(False)
        Me.GB_Help.ResumeLayout(False)
        Me.GB_Description.ResumeLayout(False)
        Me.ResumeLayout(False)
        Me.PerformLayout()

    End Sub

#End Region

    ' Global Variable
    Dim MX_Common As New MXCommon.MXCommon
    Dim MSXE_301x As New MSXE301x.MSXE301x

    Dim DataFormat As UInt64
    Dim NbrOfChannel As ULong
    Dim ChannelMask As UInt64
    Dim ChannelType(16) As UInt64
    Dim SocketClient As Socket = Nothing
    Dim DisplayText As String = ""
    Dim Client As AddiData.ADDISocket.AsyncClientStream = Nothing
    Dim ulType(16) As UInt64

    Dim CB_Gain(16) As ComboBox
    Dim CHB_Channel(16) As CheckBox
    Dim CB_Polarity(16) As ComboBox

    Public Function ConvertFromTime_T(ByVal time_t As Long) As DateTime
        Dim dt70 As DateTime = New DateTime(1970, 1, 1, 0, 0, 0, 0)
        Dim tickTotal As Long = dt70.Ticks + (time_t * 10000000L)
        Dim netTimeT As DateTime = New DateTime(tickTotal)

        Return netTimeT
    End Function


    Private Sub AutoRefresh_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        MX_Common.Timeout = 2000
        MSXE_301x.Timeout = 2000

        CB_Gain(0) = CB_Gain0
        CB_Gain(1) = CB_Gain1
        CB_Gain(2) = CB_Gain2
        CB_Gain(3) = CB_Gain3
        CB_Gain(4) = CB_Gain4
        CB_Gain(5) = CB_Gain5
        CB_Gain(6) = CB_Gain6
        CB_Gain(7) = CB_Gain7
        CB_Gain(8) = CB_Gain8
        CB_Gain(9) = CB_Gain9
        CB_Gain(10) = CB_Gain10
        CB_Gain(11) = CB_Gain11
        CB_Gain(12) = CB_Gain12
        CB_Gain(13) = CB_Gain13
        CB_Gain(14) = CB_Gain14
        CB_Gain(15) = CB_Gain15

        CHB_Channel(0) = CHB_Ch0
        CHB_Channel(1) = CHB_Ch1
        CHB_Channel(2) = CHB_Ch2
        CHB_Channel(3) = CHB_Ch3
        CHB_Channel(4) = CHB_Ch4
        CHB_Channel(5) = CHB_Ch5
        CHB_Channel(6) = CHB_Ch6
        CHB_Channel(7) = CHB_Ch7
        CHB_Channel(8) = CHB_Ch8
        CHB_Channel(9) = CHB_Ch9
        CHB_Channel(10) = CHB_Ch10
        CHB_Channel(11) = CHB_Ch11
        CHB_Channel(12) = CHB_Ch12
        CHB_Channel(13) = CHB_Ch13
        CHB_Channel(14) = CHB_Ch14
        CHB_Channel(15) = CHB_Ch15

        CB_Polarity(0) = CB_Polarity0
        CB_Polarity(1) = CB_Polarity1
        CB_Polarity(2) = CB_Polarity2
        CB_Polarity(3) = CB_Polarity3
        CB_Polarity(4) = CB_Polarity4
        CB_Polarity(5) = CB_Polarity5
        CB_Polarity(6) = CB_Polarity6
        CB_Polarity(7) = CB_Polarity7
        CB_Polarity(8) = CB_Polarity8
        CB_Polarity(9) = CB_Polarity9
        CB_Polarity(10) = CB_Polarity10
        CB_Polarity(11) = CB_Polarity11
        CB_Polarity(12) = CB_Polarity12
        CB_Polarity(13) = CB_Polarity13
        CB_Polarity(14) = CB_Polarity14
        CB_Polarity(15) = CB_Polarity15


    End Sub

    Private Sub AutoRefresh_FormClosed(ByVal sender As System.Object, ByVal e As System.Windows.Forms.FormClosedEventArgs) Handles MyBase.FormClosed
    End Sub

    Private Sub CB_TriggerMask_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CB_TriggerMask.SelectedIndexChanged
        If (CB_TriggerMask.SelectedIndex <> 0) Then
            CB_TriggerMode.Enabled = True
        Else
            CB_TriggerMode.Enabled = False
            TB_NbrOfSeqForEachTrigger.Enabled = False
            CB_HardwareTriggerEdge.Enabled = False
            TB_HardwareTriggerCount.Enabled = False

        End If

        If (CB_TriggerMask.SelectedIndex = 1) Then
            CB_HardwareTriggerEdge.Enabled = True
            TB_HardwareTriggerCount.Enabled = True
        End If

        If (CB_TriggerMask.SelectedIndex = 2) Then
            CB_HardwareTriggerEdge.Enabled = False
            TB_HardwareTriggerCount.Enabled = False
        End If

        If (CB_TriggerMask.SelectedIndex = 3) Then
            CB_HardwareTriggerEdge.Enabled = True
            TB_HardwareTriggerCount.Enabled = True
        End If
    End Sub

    Private Sub CB_TriggerMode_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CB_TriggerMode.SelectedIndexChanged
        If (CB_TriggerMode.SelectedIndex = 1) Then
            TB_NbrOfSeqForEachTrigger.Enabled = True
        Else
            TB_NbrOfSeqForEachTrigger.Enabled = False
        End If
    End Sub

    Private Sub RB_SOAP_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RB_SOAP.CheckedChanged
        L_Info.Visible = False
    End Sub

    Private Sub RB_DataServer_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RB_DataServer.CheckedChanged
        L_Info.Visible = True
    End Sub


    Private Sub CHB_Channel_CheckStateChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CHB_Ch0.CheckStateChanged, CHB_Ch1.CheckStateChanged, CHB_Ch2.CheckStateChanged, CHB_Ch3.CheckStateChanged, CHB_Ch4.CheckStateChanged, CHB_Ch5.CheckStateChanged, CHB_Ch6.CheckStateChanged, CHB_Ch7.CheckStateChanged, _
                                                                                                                  CHB_Ch8.CheckStateChanged, CHB_Ch9.CheckStateChanged, CHB_Ch10.CheckStateChanged, CHB_Ch11.CheckStateChanged, CHB_Ch12.CheckStateChanged, CHB_Ch13.CheckStateChanged, CHB_Ch14.CheckStateChanged, CHB_Ch15.CheckStateChanged
        Dim i As Integer
        For i = 0 To 15
            If Not IsNothing(CHB_Channel(i)) Then
                If (CHB_Channel(i).Enabled = True) Then

                    CB_Gain(i).Enabled = CHB_Channel(i).Checked
                    CB_Polarity(i).Enabled = CHB_Channel(i).Checked
                End If
            End If
        Next i

    End Sub

    Private Sub B_StartSample_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles B_StartSample.Click
        Dim syserrno As Integer = 0
        Dim i_Error As Integer = 0
        Dim pulGain As MSXE301x.unsignedLong16FixedArrayParam = New MSXE301x.unsignedLong16FixedArrayParam()
        Dim pulPolarity As MSXE301x.unsignedLong16FixedArrayParam = New MSXE301x.unsignedLong16FixedArrayParam()
        Dim pResponse As MSXE301x.DefaultResponse = New MSXE301x.DefaultResponse()
        Dim ulAverageMode As UInt64 = 0
        Dim ulAverageValue As UInt64 = 0
        Dim ulConversionTime As UInt64 = 0
        Dim ulConversionTimeUnit As UInt64 = 0
        Dim ulTriggerMask As UInt64 = 0
        Dim ulTriggerMode As UInt64 = 0
        Dim ulHardwareTriggerCount As UInt64 = 0
        Dim ulByTriggerNbrOfSeqToAcquire As UInt64 = 0
        Dim ulHardwareTriggerEdge As UInt64 = 0
        Dim Counter As UInt64 = 0
        Dim ClientThread As Thread
        Dim ulCpt As UInt64 = 0
        Dim ulTypeCpt As UInt64 = 0

        ReDim pulGain.ulValue(16)
        ReDim pulPolarity.ulValue(16)

        ChannelMask = 0
        NbrOfChannel = 0
        DataFormat = 0

        ' CHANNEL CONFIGURATION
        For Counter = 0 To 15
            If (CHB_Channel(Counter).Checked = True) Then
                ChannelMask = ChannelMask Or Convert.ToUInt64(1 << Convert.ToInt32(Counter))
                pulGain.ulValue(Counter) = CB_Gain(Counter).SelectedIndex + 1
                pulPolarity.ulValue(Counter) = CB_Polarity(Counter).SelectedIndex
                NbrOfChannel = NbrOfChannel + 1
            End If
        Next Counter



        ' TRIGGER CONFIGURATION
        ulTriggerMask = CB_TriggerMask.SelectedIndex
        If ((ulTriggerMask = 1) Or (ulTriggerMask = 3)) Then
            ulHardwareTriggerEdge = CB_HardwareTriggerEdge.SelectedIndex + 1
            ulHardwareTriggerCount = Convert.ToUInt64(TB_HardwareTriggerCount.Text.ToString(), 10)
        End If

        If (ulTriggerMask <> 0) Then
            ulTriggerMode = CB_TriggerMode.SelectedIndex + 1
            ulByTriggerNbrOfSeqToAcquire = Convert.ToUInt64(TB_NbrOfSeqForEachTrigger.Text.ToString(), 10)
        End If

        ' AVERAGE CONFIGURATION
        ulAverageMode = CB_AverageMode.SelectedIndex
        If (ulAverageMode <> 0) Then
            ulAverageValue = Convert.ToUInt64(TB_AverageValue.Text.ToString(), 10)
        End If

        ' CONVERSION TIME CONFIGURATION
        ulConversionTimeUnit = CB_ConversionTimeUnit.SelectedIndex
        ulConversionTime = Convert.ToUInt64(TB_ConversionTimeValue.Text.ToString(), 10)

        ' Create the client stream
        Client = New AddiData.ADDISocket.AsyncClientStream()

        ' DATA FORMAT CONFIGURATION
        Client.SingleFramesSize = (NbrOfChannel * 4) + 4
        Client.NbrOfFrames = 1

        If (CHB_DataFormatTimeStamp.Checked) Then
            DataFormat = DataFormat Or 1
            Client.SingleFramesSize = Client.SingleFramesSize + 8
        End If

        If (CHB_DataFormatAnalogValue.Checked) Then
            DataFormat = DataFormat Or 2
        End If

        If ((TB_IPAddress_0.Text.ToString() = "") Or (TB_IPAddress_1.Text.ToString() = "") Or (TB_IPAddress_2.Text.ToString() = "") Or (TB_IPAddress_3.Text.ToString() = "")) Then
            MessageBox.Show("The IP address you enter is not valid, please try again.", "IP address error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
        Else
            If ((Convert.ToUInt64(TB_IPAddress_0.Text.ToString(), 10) >= 0) And (Convert.ToUInt64(TB_IPAddress_0.Text.ToString(), 10) < 256)) Then
                If ((Convert.ToUInt64(TB_IPAddress_1.Text.ToString(), 10) >= 0) And (Convert.ToUInt64(TB_IPAddress_1.Text.ToString(), 10) < 256)) Then
                    If ((Convert.ToUInt64(TB_IPAddress_2.Text.ToString(), 10) >= 0) And (Convert.ToUInt64(TB_IPAddress_2.Text.ToString(), 10) < 256)) Then
                        If ((Convert.ToUInt64(TB_IPAddress_3.Text.ToString(), 10) >= 0) And (Convert.ToUInt64(TB_IPAddress_3.Text.ToString(), 10) < 256)) Then
                            MX_Common.Url = "http://" + TB_IPAddress_0.Text + "." + TB_IPAddress_1.Text + "." + TB_IPAddress_2.Text + "." + TB_IPAddress_3.Text + ":5555"
                            MSXE_301x.Url = MX_Common.Url


                            Try
                                pResponse = MSXE_301x.AnalogInputGetChannelType(0, ulType)
                                If (pResponse.iReturnValue = 0) Then
                                    SocketClient = Nothing
                                    ClientThread = Nothing

                                    For ulCpt = 0 To 15
                                        If ((ChannelMask & Math.Pow(2, ulCpt)) <> 0) Then
                                            ChannelType(ulTypeCpt) = ulType(ulCpt)
                                            ulTypeCpt = ulTypeCpt + 1
                                        End If
                                    Next ulCpt

                                    ' Test if receive data via the data server
                                    If (RB_DataServer.Checked = True) Then
                                        ' Open the socket connection to receive the data
                                        SocketClient = New Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp)
                                        SocketClient.Connect(TB_IPAddress_0.Text + "." + TB_IPAddress_1.Text + "." + TB_IPAddress_2.Text + "." + TB_IPAddress_3.Text, 8989)
                                        SocketClient.ReceiveBufferSize = 1048576

                                        ' Start the first read socket 
                                        ' Start the read socket and the user thread
                                        Client.Start(SocketClient)
                                        ClientThread = New Thread(AddressOf ClientThreadFct)
                                    End If

                                    DisplayText = ""

                                    i_Error = MSXE_301x.AnalogInputInitAndStartAutoRefresh(ChannelMask, pulGain, pulPolarity, ulAverageMode, ulAverageValue, ulConversionTime, _
                                        ulConversionTimeUnit, ulTriggerMask, ulTriggerMode, ulHardwareTriggerEdge, ulHardwareTriggerCount, ulByTriggerNbrOfSeqToAcquire, DataFormat, 0, 0, 0, syserrno)
                                    If (i_Error <> 0) Then
                                        MessageBox.Show("AnalogInputInitAndStartAutoRefresh Error : " + i_Error.ToString(), "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                                    Else
                                        DisplayTimer.Enabled = True

                                        ' Test if receive data via the data server
                                        If (RB_DataServer.Checked = True) Then
                                            ClientThread.Priority = ThreadPriority.Lowest
                                            ClientThread.Start()
                                        Else
                                            ReadTimer.Enabled = True
                                        End If

                                        GB_Average.Enabled = False
                                        GB_Channel.Enabled = False
                                        GB_ConversionTime.Enabled = False
                                        GB_DataFormat.Enabled = False
                                        GB_Trigger.Enabled = False
                                        B_StartSample.Enabled = False
                                        B_StopSample.Enabled = True
                                        DisplayTimer.Enabled = True
                                        GB_AcquisitionMode.Enabled = False
                                    End If
                                Else
                                    MessageBox.Show("AnalogInputGetChannelType Error : " + i_Error.ToString(), "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                                End If

                            Catch Ex As Exception
                                MessageBox.Show("Exception occur : " + Ex.Message, "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                            End Try

                            If (B_StopSample.Enabled = False) Then
                                B_StopSample_Click(sender, Nothing)
                            End If
                        Else
                            MessageBox.Show("The IP address (part 4) you enter is not valid, please try again.", "IP address error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                        End If
                    Else
                        MessageBox.Show("The IP address (part 3) you enter is not valid, please try again.", "IP address error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                    End If
                Else
                    MessageBox.Show("The IP address (part 2) you enter is not valid, please try again.", "IP address error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                End If
            Else
                MessageBox.Show("The IP address (part 1) you enter is not valid, please try again.", "IP address error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            End If
        End If
    End Sub

    Private Sub B_StopSample_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles B_StopSample.Click
        Dim syserrno As Integer = 0
        Dim i_Error As Integer = 0

        DisplayTimer.Enabled = False
        ReadTimer.Enabled = False

        ' Test if socket open
        If (Not IsNothing(SocketClient)) Then
            If (Not IsNothing(Client)) Then
                Client.Stoop()
            End If

            Try
                ' Close the socket connection
                SocketClient.Disconnect(False)
                SocketClient.Close()
                SocketClient = Nothing
                System.GC.Collect()
            Catch Ex As Exception
                MessageBox.Show("Socket close connection exception occur : " + Ex.Message, "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            End Try
        End If

        If (B_StopSample.Enabled = True) Then
            Try
                i_Error = MSXE_301x.AnalogInputStopAndReleaseAutoRefresh(syserrno)
                If (i_Error <> 0) Then
                    MessageBox.Show("AnalogInputStopAndReleaseAutoRefresh Error : " + i_Error.ToString(), "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                End If

            Catch Ex As Exception
                MessageBox.Show("AnalogInputStopAndReleaseAutoRefresh Exception occur : " + Ex.Message, "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            End Try

            GB_Average.Enabled = True
            GB_Channel.Enabled = True
            GB_ConversionTime.Enabled = True
            GB_DataFormat.Enabled = True
            GB_Trigger.Enabled = True
            B_StartSample.Enabled = True
            B_StopSample.Enabled = False
            GB_AcquisitionMode.Enabled = True
        End If
    End Sub

    Private Sub ClientThreadFct()
        Dim sOutString As String
        Dim Value As UInt32 = 0
        Dim Counter As UInt32 = 0
        Dim sValue As Single = 0
        Dim TimeStampLow As ULong = 0
        Dim TimeStampHigh As ULong = 0
        Dim TimeStampLowmus As ULong = 0
        Dim TimeStampLowms As ULong = 0
        Dim SocketData(Client.SingleFramesSize) As Byte
        Dim sUnit(2) As String

        sUnit(0) = " V "
        sUnit(1) = " mA "

        While (True)
            SocketData = Client.ReadData()

            If (Not IsNothing(SocketData)) Then
                sOutString = ""

                ' Display the received value
                If (DataFormat = 0) Then
                    Value = BitConverter.ToUInt32(SocketData, (0))
                    sOutString = "Counter: " + Value.ToString()

                    For Counter = 0 To NbrOfChannel - 1
                        Value = BitConverter.ToUInt32(SocketData, (Counter * 4) + 4)
                        sOutString = sOutString + " " + Value.ToString("X")
                    Next Counter
                End If

                If (DataFormat = 1) Then
                    TimeStampHigh = BitConverter.ToUInt32(SocketData, 0)
                    TimeStampLow = BitConverter.ToUInt32(SocketData, 4)
                    TimeStampLowms = TimeStampLow / 1000
                    TimeStampLowmus = TimeStampLow Mod 1000
                    sOutString = "Time stamp: " + ConvertFromTime_T(TimeStampHigh).ToString() + "." + TimeStampLowms.ToString("D3") + "." + TimeStampLowmus.ToString("D3")
                    Value = BitConverter.ToUInt32(SocketData, 8)
                    sOutString = sOutString + " Counter: " + Value.ToString()
                    sOutString = sOutString + " Channel value(s) :"
                    For Counter = 0 To NbrOfChannel - 1
                        Value = BitConverter.ToUInt32(SocketData, (Counter * 4) + 12)
                        sOutString = sOutString + " " + Value.ToString("X")
                    Next Counter
                End If

                If (DataFormat = 2) Then
                    Value = BitConverter.ToUInt32(SocketData, 0)
                    sOutString = "Counter: " + Value.ToString()
                    sOutString = sOutString + " Channel value(s) :"
                    For Counter = 0 To NbrOfChannel - 1
                        sValue = BitConverter.ToSingle(SocketData, (Counter * 4) + 4)
                        sOutString = sOutString + " " + sValue.ToString("F3") + sUnit(ChannelType(Counter))
                    Next Counter
                End If

                If (DataFormat = 3) Then
                    TimeStampHigh = BitConverter.ToUInt32(SocketData, 0)
                    TimeStampLow = BitConverter.ToUInt32(SocketData, 4)
                    TimeStampLowms = TimeStampLow / 1000
                    TimeStampLowmus = TimeStampLow Mod 1000
                    sOutString = "Time stamp: " + ConvertFromTime_T(TimeStampHigh).ToString() + "." + TimeStampLowms.ToString("D3") + "." + TimeStampLowmus.ToString("D3")
                    Value = BitConverter.ToUInt32(SocketData, 8)
                    sOutString = sOutString + " Counter: " + Value.ToString()
                    sOutString = sOutString + " Channel value(s) :"
                    For Counter = 0 To NbrOfChannel - 1
                        sValue = BitConverter.ToSingle(SocketData, (Counter * 4) + 12)
                        sOutString = sOutString + " " + sValue.ToString("F3") + sUnit(ChannelType(Counter))
                    Next Counter
                End If

                DisplayText = sOutString

            Else
                Exit While
            End If
        End While
    End Sub

    Private Sub ReadTimer_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ReadTimer.Tick
        Dim Values(16) As ULong
        Dim Cpt As UInt32
        Dim TestChannel As UInt32
        Dim sOutString As String
        Dim sValue As Single = 0
        Dim TimeStampLow As ULong = 0
        Dim TimeStampHigh As ULong = 0
        Dim TimeStampLowmus As ULong = 0
        Dim TimeStampLowms As ULong = 0
        Dim CounterValue As ULong = 0
        Dim sUnit(2) As String

        sUnit(0) = " V "
        sUnit(1) = " mA "

        Dim pResponse As MSXE301x.DefaultResponse = New MSXE301x.DefaultResponse()

        ' Read the auto refresh value
        pResponse = MSXE_301x.AnalogInputGetAutoRefreshValues(TimeStampLow, TimeStampHigh, CounterValue, Values)

        ' Test if error occur
        If ((pResponse.iReturnValue <> 0) Or (pResponse.syserrno <> 0)) Then
            B_StopSample_Click(sender, Nothing)
            MessageBox.Show("AnalogInputGetAutoRefreshValues Error : " + pResponse.iReturnValue.ToString(), "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
        Else
            sOutString = ""

            If ((DataFormat And 1) = 1) Then
                TimeStampLowms = TimeStampLow / 1000
                TimeStampLowmus = TimeStampLow Mod 1000
                sOutString = "Time stamp: " + ConvertFromTime_T(TimeStampHigh).ToString() + "." + TimeStampLowms.ToString("D3") + "." + TimeStampLowmus.ToString("D3") + Environment.NewLine
            End If

            ' Get the auto refresh counter value
            sOutString = sOutString + "Counter: " + CounterValue.ToString() + Environment.NewLine + "Channel value(s) :"

            ' Get the auto refresh channel mask
            TestChannel = 1
            For Cpt = 0 To 15
                ' Test if channel used
                If ((ChannelMask And TestChannel) <> 0) Then
                    If ((DataFormat And 2) = 2) Then
                        sValue = BitConverter.ToSingle(BitConverter.GetBytes(Values(Cpt)), 0)
                        sOutString = sOutString + " " + sValue.ToString("F3") + sUnit(ulType(Cpt))
                    Else
                        sOutString = sOutString + " " + Values(Cpt).ToString("X") + " Hex"
                    End If
                End If
                TestChannel = TestChannel * 2
            Next Cpt

            DisplayText = sOutString
        End If
    End Sub

    Private Sub DisplayTimer_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles DisplayTimer.Tick
        TB_Values.Text = DisplayText
    End Sub
End Class
